package org.jum.scalademo

object AnonymousFunctionExample {
  
  
  
  //Függvények felhasználhatóak más függvények paramétereként
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  /**
   * A T elemeket tartalmazó listában az elemek Int-té konvertált
   * értékeinek összegét adja vissza.
   * A konverziós függvény: f
   */
  def sumRec[T](list : List[T], f : T => Int) : Int = {
    if(list.isEmpty) 0
    else f(list.head) + sumRec(list.tail, f)
  }
  
  //Igazából nem így kellene megcsinálni,
  //mert ez nem farokrekurzív, ezért nem lehet kioptimalizálni.
  
  
  
  //Ez már farokrekurzív (a belső fv-t kell nézni):
  
  def sumTailRec[T](list : List[T], f : T => Int) : Int = {
    def sumInner(list: List[T], acc : Int) : Int = {
    	if(list.isEmpty) acc
    	else sumInner(list.tail, acc + f(list.head))
    }
    sumInner(list, 0)
  }  
  
  
  
  
  
  def main(args : Array[String]) : Unit = {
    
    case class Part(name : String, weight: Int, price: Int);
    
    val parts : List[Part] = List(
      new Part("board", 6, 40000),
      new Part("binding", 1, 25000),
      new Part("rubber", 0, 100)
    )
    
    
    
    
    def sum(list : List[Part], f : Part => Int) =
      sumTailRec(list, f)
    
    
    
    
    def weightFunction(p: Part) : Int = {
      return p.weight; //return: mindig opcionális kiírni
    }
    
    println(sum(parts, weightFunction));
    
    
    
    println(sum(
         parts,
         (p : Part) => { p.weight }
    ))
    
    
    
    println(sum(
    	parts,
        p => p.price //Ebben az esetben a típus kikövetkeztethető
    ))
    
    
    //Rövidített formula, ha nem kell nevesíteni a paramétert:
    println(sum(parts, (_ : Part).weight))
    
    
    //Kikövetkeztethető típus:
    println(sum(parts, _.price))
    
    
    
    
    
    
    
    //scala.Iterable: def  foreach(f : (A) => Unit) : Unit
    
    
    
    parts.foreach((p: Part) => { println(p.name) } )
    
    
    //Típus kikövetkeztethető, így kihagyható
    parts.foreach( p => println(p.name) )
    
    
    
    parts foreach { p => println(p.name) };
    
    //Ez mást csinál, ez a toString-eket hívogatja végig:
    parts foreach { println(_) }
  }
}
