package org.jum.scalademo

object PatternMatchingExample {
  
  def main(args : Array[String]) : Unit = {
    println(eval("a"))
    println(eval("b"))
    println(eval(1000))
    
    println(eval(1::2::Nil))
    println(eval(List(1, 4, 5)))
    
    println(eval(new Employee2(1, "Bill", "NYC")))
    println(eval(new Employee2(2, "Joe", "NYC")))
    
    println(eval(("a", "b")));
    println(eval(("c", new Employee2(2, "Joe", "NYC"))));
    println(eval(("aa", "bb", 324)));
    println(eval("1d23:59:45"));
  }
  
  
  
  
  
  
  
  //A regexp for parsing this time format: "23d14:01:23"
  val TimeRE = "(([0-9]*)d)?([0-9]{1,2}):([0-9]{2})(:([0-9]{2}))?".r;
  
  
  
  
  
  
  
  
  
  
  
  
  def eval(x : Any) : String = x match {
    case "a" => "The string literal 'a'";
    
    
    case TimeRE(_, days, hours, minutes, _, seconds) =>
      "Time: Days:" + days + " Hours:" + hours +
      " Minutes:" + minutes + " Seconds:"+ seconds;
    
      
    case s : String => "Some string: " + s;
    
    
    case i : Int => "Some integer: " + i;
    
    
    case Employee2(_, "Joe", _) => "Joe."
    
    
    case Employee2(id, name, addr) => "An employee. Name: " + name;
    
    
    case List(_, 2) => "Two-element list, second element is 2.";
    
    
    case ("a", _) => "Some tuple with two elements. First element is 'a'.";
    
    
    case (_, e @ Employee2(_, "Joe", _)) => "Some tuple with two elements. Second element is Joe.";
    
    
    case (_, _) => "Some tuple with two elements.";
    
    
    case (a, b, c) => "Some tuple with three elements which are: " + a + ", " + b + " and " + c;
    
    
    case _ => "Whatever";
  } 
  
}
