package org.jum.scalademo


trait Clickable {
  def click()
}














class Button2(val label: String) extends Widget with Clickable {
  def click() = {
    // Logic to give the appearance of clicking a button...
    println("Button2 is clicked.");
  }
}

//It would be also applicable:
//class Button2(val label: String) extends Button(label) with Clickable;

  
  
  
trait ObservableClicks extends Clickable with Observable {
  abstract override def click() = {
    println("ObservableClicks click invoked.")
    super.click()
    notifyObservers
  }
}










object StackableTraitExample {
  def main(args : Array[String]) : Unit = {
    
      println("\nExample 1.");
	  val observableButton = new Button2("Okay")
          with ObservableClicks
      val buttonClickCountObserver = new ButtonCountObserver
      observableButton.addObserver(buttonClickCountObserver)

      for (i <- 1 to 3) observableButton.click()
      println("Click count: " + buttonClickCountObserver.count);
      
      
      
      
      
      
      
      
		trait VetoableClicks extends Clickable {
		  val maxAllowed = 1  // default
		  private var count = 0
		
		  abstract override def click() = {
		    println("VetoableClicks click invoked.")
		    if (count < maxAllowed) {
		      count += 1
		      super.click()
		    } else {
		      println("Vetoed.")
		    }
		  }
		}
      
  
  
      println("\nExample 2. - with ObservableClicks with VetoableClicks");
      val observableButton2 =
          new Button2("Okay") with
        ObservableClicks with VetoableClicks
      
      val buttonClickCountObserver2 = new ButtonCountObserver
      observableButton2.addObserver(buttonClickCountObserver2)

      for (i <- 1 to 3) observableButton2.click()
      println("Click count: " + buttonClickCountObserver2.count);
      
      
      
      
      println("\nExample 3. - with VetoableClicks with ObservableClicks");
      val observableButton3 =
          new Button2("Okay") with VetoableClicks with ObservableClicks
      
      val buttonClickCountObserver3 = new ButtonCountObserver
      observableButton3.addObserver(buttonClickCountObserver3)

      for (i <- 1 to 3) observableButton3.click()
      println("Click count: " + buttonClickCountObserver3.count);



  }
}
